
/******************************************************************************
 *
 * List.H
 *
 ******************************************************************************/

typedef int *ListData;

typedef struct __ListNode {
  struct __ListNode *previous;
  struct __ListNode *next;
  ListData           data;
} _ListNode, *ListNode, ListNodeStruct, *ListNodePtr, *ListNodeP, vlistnode_t;

typedef struct {
  ListNode head;
  ListNode tail;
} _List, *List, ListStruct, *ListPtr, *ListP, *vlist_ptr_t, vlist_t;

#define TraverseList(xhead,xtemp) \
  for ((xtemp)=(xhead).head;(xtemp);(xtemp)=(xtemp)->next)

#define DualTraverseList(xhead1,xtemp1,xhead2,xtemp2)    \
  for ((xtemp1)=(xhead1).head, (xtemp2)=(xhead2).head;   \
       (xtemp1) && (xtemp2);                             \
       (xtemp1)=(xtemp1)->next, (xtemp2)=(xtemp2)->next)

extern List     ListAlloc        (void);
extern Status   ListDealloc      (List list);
extern ListNode ListNodeAlloc    (void);
extern Status   ListNodeDealloc  (ListNode node);
extern Status   ListNodesDealloc (List list);
extern Status   ListInit         (List list);
extern ListNode ListAppend       (List list, Pointer data);
extern ListNode ListPreface      (List list, Pointer data);
